#pragma once

#include "TsStreamEngine/TsStream.h"
#include "Common/Lock.h"
#include <commctrl.h>
#include <map>
#include <vector>
#include <set>

#define FILTWND_ENABLE_TIPWND		// ToolTipOffɂȂRgAEg

#ifdef FILTWND_ENABLE_TIPWND
	#define FILTWND_TIP_WIDTH			500
	#define FILTWND_TIP_TEXTCOLOR		RGB(0,0,0)
	#define FILTWND_TIP_BGCOLOR			RGB(255,255,200)
	#define FILTWND_TIP_NODATA			""
	#define FILTWND_TIP_MAX_EVENTSTR	1024

	#define FILTWND_TIP_NEXTEVENT	// ݂̎̔ԑg̏擾邩B(RgAEgŎ擾Ȃ)
#endif


#define FILTWND_TAB_SERVICEID		0
#define FILTWND_TAB_CHANNELNAME		1
#define FILTWND_TAB_CURRENTEVENT	2
#define FILTWND_TAB_PMTPID			3
#define FILTWND_TAB_PIDLIST			4

// fbhbNNWindowProcŏ邽߂
#define WM_FILTWND_STATUSRESET	(WM_APP+0x00)
#define WM_FILTWND_DELETEALL	(WM_APP+0x01)
#define WM_FILTWND_ADDITEM		(WM_APP+0x02)
#define WM_FILTWND_SETSUBITEM	(WM_APP+0x03)
// TuACe̒ʒm
#define WM_FILTWND_NOTIFYSCROLL		(WM_APP+0x10)
#define WM_FILTWND_NOTIFYMOUSEWHEEL	(WM_APP+0x11)

struct FILTWND_EVENTDATA
{
	// stProgram̂̂g悤ɕύX
//	BYTE byType;
//	WORD wEventID;
//	BYTE byVer;
	struct TSEPG_PROGRAM stProgram;
};

// Key=T[rXID Val=Data
struct FILTWND_SERVICEDATA
{
	WORD wServiceID;
	WORD wPosition;

	std::vector<WORD> *pPIDs;
	struct FILTWND_EVENTDATA stCurrnetEvent;
#ifdef FILTWND_ENABLE_TIPWND
	struct FILTWND_EVENTDATA stNextEvent;
	struct
	{
		char szChName[30];
		char szPresentEvent[FILTWND_TIP_MAX_EVENTSTR];
		char szFutureEvent[FILTWND_TIP_MAX_EVENTSTR];
	} stTipString;
#endif
};

typedef std::map<WORD,FILTWND_SERVICEDATA*>		FiltWndServiceListMap;
typedef std::pair<WORD,FILTWND_SERVICEDATA*>	FiltWndServiceListPair;

// Key=Position Val=T[rXID(tp)
typedef std::map<WORD,WORD>						FiltWndPosToServiceIDMap;
typedef std::pair<WORD,WORD>					FiltWndPosToServiceIDPair;

#ifdef FILTWND_ENABLE_TIPWND
struct FILTWND_TOOLTIP
{
	TOOLINFO stToolTipInfo;
};
typedef std::vector<FILTWND_TOOLTIP>	FiltWndToolTip;
#endif

// pPbgtB^wp
typedef void (CALLBACK PF_FILTERWND_SETFILTER)(WORD *pwDenyServiceList,int iDenyServiceNum,WORD *pwDenyPidList,int iDenyPidNum,LPVOID lpContext);

// EPG₢킹p(wServiceID,wDate,dwSecɍvf[^pEpgDataɖ߂BȂꍇFALSE߂)
typedef BOOL (CALLBACK PF_FILTERWND_EPGCALLBACK)(WORD wServiceID,DateTime &stTime,struct TSEPG_PROGRAM *pEpgData,BOOL bDeleteFlg,LPVOID lpContext);

// ^\vp
typedef BOOL (CALLBACK PF_FILTERWND_SCHEDULE_BYTIME_CALLBACK)(WORD wServiceID,DateTime &stStartTime,DWORD dwRecTime,char *lpszName,LPVOID lpContext);
typedef BOOL (CALLBACK PF_FILTERWND_SCHEDULE_BYEVENTID_CALLBACK)(WORD wNetworkID,WORD wStreamID,WORD wServiceID,WORD wEventID,char *lpszName,LPVOID lpContext);

// fobOp
#ifdef _DEBUG
typedef void (CALLBACK PF_FILTERWND_DEBUG_DUMPEPG_REQUEST_CALLBACK)(WORD wServiceID,char *lpszOutputPath,LPVOID lpContext);
#endif

struct FILTWND_PMTITEM
{
	BYTE	byType;
	WORD	wPID;
};

class CFilterWnd
{
public:
	CFilterWnd(HINSTANCE m_hInst);
	~CFilterWnd(void);

	void Reset()
	{
		PostMessage(m_hWnd,WM_FILTWND_STATUSRESET,0,0);		
	}
	void SetFilterCallback(PF_FILTERWND_SETFILTER *lpFunc,LPVOID lpContext)
	{
		m_lpSetFilterFunc = lpFunc;
		m_lpSetFilterContext = lpContext;
	}
	void SetScheduleByTimeCallback(PF_FILTERWND_SCHEDULE_BYTIME_CALLBACK *lpFunc,LPVOID lpContext)
	{
		m_lpScheduleTimeFunc = lpFunc;
		m_lpScheduleTimeContext = lpContext;
	}
	void SetScheduleByEventIDCallback(PF_FILTERWND_SCHEDULE_BYEVENTID_CALLBACK *lpFunc,LPVOID lpContext)
	{
		m_lpScheduleEventIDFunc = lpFunc;
		m_lpScheduleEventIDContext = lpContext;
	}
#ifdef _DEBUG
	void SetDebugDumpEpgRequestCallback(PF_FILTERWND_DEBUG_DUMPEPG_REQUEST_CALLBACK *lpFunc,LPVOID lpContext)
	{
		m_lpDebugEpgDumpFunc = lpFunc;
		m_lpDebugEpgDumpContext = lpContext;
	}
#endif
	BOOL IsWindowVisible() { return ::IsWindowVisible(m_hWnd); }
	BOOL ShowWindow(int iShowMode) { return ::ShowWindow(m_hWnd,iShowMode); }

	BOOL Create(HINSTANCE hInst,int iResource,HWND hParentWnd,BOOL bNoPosSize,int x,int y,int sx,int sy,int iShowMode);
	void Destroy(int *pX ,int *pY,int *pSX,int *pSY,BOOL *pbShow);
	void SetEnable(BOOL bEnable);
	void DeleteAllItems();
	void AddService(WORD wServiceID,WORD wPmtPID);
	void SetPMT(WORD wServiceID,struct FILTWND_PMTITEM *pstPmtItem,int iNum);
	void SetServiceName(WORD wServiceID,char *pszChName);
	void SetCurrentEPG(DateTime &stCurrentTime,PF_FILTERWND_EPGCALLBACK *lpFunc,LPVOID lpContext);	

protected:
	HINSTANCE m_hInst;
	HWND m_hWnd;
	HMENU m_hMenu;
	LOCK_OBJ m_stLock;
	FiltWndServiceListMap m_Service;
	FiltWndPosToServiceIDMap m_PosToService;
	BOOL m_bPacketFilter;

	PF_FILTERWND_SETFILTER *m_lpSetFilterFunc;
	LPVOID	m_lpSetFilterContext;

	PF_FILTERWND_SCHEDULE_BYTIME_CALLBACK *m_lpScheduleTimeFunc;
	LPVOID m_lpScheduleTimeContext;

	PF_FILTERWND_SCHEDULE_BYEVENTID_CALLBACK *m_lpScheduleEventIDFunc;
	LPVOID m_lpScheduleEventIDContext;

	LRESULT FilterDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
	void OnInitDialog();
	void OnSize();
	BOOL SetSubItem(WORD wServiceID,WORD wSubIndex,char *lpszText);
	void MakeEventStrings(DWORD dwFlags,char *lpszBuf,int iBufLen,DateTime &stStart,DateTime &stEnd,char *szTitle,char *szDetail,BYTE byVideoType,BYTE byAudioType);
	void CreateFilterList(WORD** ppwServiceList,int *piServiceNum,WORD **ppwPidList,int *piPidNum);
	void OnPacketFilterBtn(BOOL bForceOff=FALSE);
	BOOL OnRecSchedule(int iFlg);
	BOOL OnRecSchedule_ByEventID(int iFlg);

	// fobOp
#ifdef _DEBUG
	PF_FILTERWND_DEBUG_DUMPEPG_REQUEST_CALLBACK *m_lpDebugEpgDumpFunc;
	LPVOID m_lpDebugEpgDumpContext;
	void OnDebug();
#endif

#ifdef FILTWND_ENABLE_TIPWND
	// Tip֘A
	HWND m_hTip;
	FiltWndToolTip m_Tooltip;
	void UpdateToolTip(HWND hListView);
	BOOL MousePt_to_ListViewItem(POINT ptMouse,int *piItem,int *piSubItem);
#endif

protected:
	// WindowProc(Dummy)
	static LRESULT CALLBACK _FilterDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
	{
	#pragma warning(disable: 4312)
		CFilterWnd* pThis=reinterpret_cast<CFilterWnd*>(GetWindowLongPtr(hDlg,GWL_USERDATA));
	#pragma warning(default: 4312)
		if(message==WM_INITDIALOG)
		{
			{
				pThis=(CFilterWnd*)lParam;
	#pragma warning(disable: 4244)
				SetWindowLongPtr(hDlg,GWL_USERDATA,reinterpret_cast<LONG_PTR>(pThis));
	#pragma warning(default: 4244)
			}
		}
		if(pThis)
		{
			return pThis->FilterDlg(hDlg,message,wParam,lParam);
		} else {
			return FALSE;
		}
	}
};
